"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.execWrapped = void 0;
const exec_1 = __importDefault(require("@simplyhexagonal/exec"));
function execWrapped({ command }) {
    return __awaiter(this, void 0, void 0, function* () {
        const { execPromise, execProcess } = (0, exec_1.default)(command);
        const execResult = yield execPromise;
        if (execResult.exitCode !== 0) {
            throw new Error(execResult.stderrOutput);
        }
        console.log(execResult.stdoutOutput);
        return { execProcess, execPromise, execResult };
    });
}
exports.execWrapped = execWrapped;
