#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const commander_1 = require("commander");
const npm_pull_1 = require("./npm-pull");
main();
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        commander_1.program
            .name('npm-pull')
            .description('Pull latest version of a package from npm')
            .addHelpText('after', `
   
   Before pulling, if there are unstaged changes, it throws an error that tells you to stash (git stash) or commit (git commit) your changes.`);
        commander_1.program.option('--package-name @deep-foundation/npm-release', 'Package name');
        commander_1.program.parse(process.argv);
        const { packageName } = commander_1.program.opts();
        if (!packageName) {
            throw new Error('Package name is required');
        }
        yield (0, npm_pull_1.npmPull)({
            packageName
        });
    });
}
