"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.npmPull = void 0;
const exec_1 = __importDefault(require("@simplyhexagonal/exec"));
const fs_extra_1 = require("fs-extra");
const path_1 = require("path");
function npmPull({ packageName }) {
    return __awaiter(this, void 0, void 0, function* () {
        const { execPromise: gitDiffExecPromise } = (0, exec_1.default)(`git diff`);
        const gitDiffResult = yield gitDiffExecPromise;
        if (gitDiffResult.stdoutOutput) {
            throw new Error('You have unstaged changes. Stash (git stash) or commit (git commit) them');
        }
        const { execPromise: npmInstallExecPromise } = (0, exec_1.default)(`npm install ${packageName}@latest --no-save`);
        const npmInstallResult = yield npmInstallExecPromise;
        if (npmInstallResult.exitCode !== 0) {
            throw new Error(npmInstallResult.stderrOutput.trim());
        }
        yield (0, fs_extra_1.rename)((0, path_1.resolve)(`node_modules/${packageName}`), (0, path_1.resolve)(`./`));
    });
}
exports.npmPull = npmPull;
