"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.npmRelease = void 0;
const exec_1 = __importDefault(require("@simplyhexagonal/exec"));
const exec_wrapped_1 = require("./exec-wrapped");
const update_version_in_json_object_1 = require("./update-version-in-json-object");
function npmRelease({ deepJsonFilePath, newVersion, packageJsonPath }) {
    return __awaiter(this, void 0, void 0, function* () {
        const packageJson = yield Promise.resolve(`${packageJsonPath}`).then(s => __importStar(require(s)));
        const { execPromise } = (0, exec_1.default)(`npm view ${packageJson.name} version`);
        const execResult = yield execPromise;
        if (execResult.exitCode !== 0) {
            throw new Error(execResult.stderrOutput.trim());
        }
        const npmLatestPackageJsonVersion = execResult.stdoutOutput.toString().trim();
        const packageJsonVersion = packageJson.version;
        if (npmLatestPackageJsonVersion > packageJsonVersion) {
            throw new Error(`Version ${packageJson.version} in ${packageJsonPath} is outdated. Latest version in npm is ${npmLatestPackageJsonVersion}. Execute npm-pull`);
        }
        if (npmLatestPackageJsonVersion === packageJsonVersion) {
            yield (0, exec_wrapped_1.execWrapped)({
                command: `npm version --allow-same-version ${newVersion}`,
            });
            yield (0, update_version_in_json_object_1.updateDeepJsonVersion)({
                version: newVersion,
                filePath: deepJsonFilePath,
            });
        }
        if (npmLatestPackageJsonVersion < packageJsonVersion) {
            yield (0, exec_wrapped_1.execWrapped)({ command: `npm version ${packageJsonVersion}` });
            yield (0, update_version_in_json_object_1.updateDeepJsonVersion)({
                version: newVersion,
                filePath: deepJsonFilePath,
            });
        }
    });
}
exports.npmRelease = npmRelease;
